function [cfo_est,cfo_ests] = est_CFO(IQ,N_STS,num_det)
%ESTIMATE CFO (CARRIER FREQUENCY OFFSET) FROM IQ DATA CONTAINING STS
%(SHORT TRAINING SEQUENCE) WHICH REPEATS num_det TIMES.

IQ              = reshape(IQ,1,length(IQ));
cfo_ests        = zeros(num_det,1);
for j = 1:num_det
    sts_ind1    = ( (j-1)*N_STS+1 ):( j*N_STS );
    sts_ind2    = (sts_ind1(end)+1):sts_ind1(end)+N_STS;
    cfo_ests(j) = IQ(sts_ind1)*IQ(sts_ind2)';
end
cfo_est         = mean(angle(cfo_ests))/(pi*N_STS);
end

