%% MIMO CALIBRATION SOUNDER

clear all
clc
rng(1)

%% PARAMETERS
N_TX        = 8;                            %num transmitters                  
Tx_t        = zeros(N_TX, 2^14);
N           = 2^14;

for i = 1:N_TX
    F               = zeros(1,N);
    F(246+10*i)     = exp(1i*2*pi*rand(1,1));
    T               = ifft(F,N);
    Tx_t(i,:)       = T./max(abs(T));
end

Tx_t(2:7,:)         = 0;
Tx_t                = .8*[Tx_t(1,:)];
%% Write to binary files
for j = 1:1
    filename1           = strcat('outside_real',num2str(j),'.bin');
    filename2           = strcat('outside_imag',num2str(j),'.bin');
    write_to_binary(Tx_t(j,:),filename1,filename2)
end

% GBs                 = [1:N_Gs,(N/2)-N_Gs:(N/2)+N_Gs,N-N_Gs:N];%guard bands for sounder
% save('RUSK_zc_sounder.mat','sts_t','sts_f','zc','Tx_t','GBs','GI','F','T','Pilots','interval');

%% Test processing
% rx      = sum(Tx_t);
% det     = abs(xcorr(rx,zc));
% det(det<200) = 0;
% det     = det(length(rx)-1:end);
% [~,inds] = findpeaks(det);
% inds    = sort(inds,'ascend');
% aoi     = rx(inds(1)-1+length(zc):inds(1)-1+length(zc)+30*16);
% 
% figure(2)
% plot(abs(xcorr(rx,zc)))
% 
% figure(3)
% plot(abs(xcorr(aoi,sts_t(1,:))))

